<template>
    <div id="person">
        <h1 class="font-weight-normal">{{ person.name }}</h1>
        <p v-if="person.born" class="my-0">Born {{ bornFormatted }}</p>
        <p v-if="person.died" class="my-0">Died {{ diedFormatted }}</p>
        <div v-if="acting.length > 0">
            <hr class="my-3">
            <h4 class="font-weight-normal">Acting</h4>
            <cast-table view="person" :roles="acting"/>
        </div>
        <div v-if="other.length > 0">
            <hr class="my-3">
            <h4 class="font-weight-normal">Works</h4>
            <crew-table view="person" :crew="other"/>
        </div>
        <div v-if="acting.length > 0 || other.length > 0">
            <hr class="my-3">
            <p>What is {{ person.name }} best known for?</p>
            <custom-select v-if="person.known_for" @select:option="updateKnownFor" table="works"
                           :specification="`person_id=${person.id}`" :selected="person"/>
            <custom-select v-else table="works" @select:option="updateKnownFor"
                           :specification="`person_id=${person.id}`"/>
        </div>
    </div>
</template>

<script>
    import CastTable from "@/components/CastTable";
    import CrewTable from "@/components/CrewTable";
    import CustomSelect from "@/components/CustomSelect";

    export default {
        name: "person",
        components: {
            CustomSelect,
            CastTable,
            CrewTable
        },
        data() {
            return {
                person: {},
                acting: [],
                other: [],
                known_for: null,
            }
        },
        mounted() {
            this.getPerson();
            this.getActing();
            this.getOther();
        },
        computed: {
            bornFormatted() {
                return this.formatDate(this.person.born)
            },
            diedFormatted() {
                return this.formatDate(this.person.died)
            },
        },
        methods: {
            async getPerson() {
                try {
                    const id = this.$route.params.id;
                    const response = await fetch(`http://localhost:8081/api/people/${id}`);
                    const data = await response.json();
                    this.person = data[0];
                } catch (e) {
                    console.error(e)
                }
            },
            async getActing() {
                try {
                    const id = this.$route.params.id;
                    const response = await fetch(
                        `http://localhost:8081/api/works?acting=true&order=e.released%20desc&person_id=${id}`
                    );
                    this.acting = await response.json();
                } catch (e) {
                    console.error(e)
                }
            },
            async getOther() {
                try {
                    const id = this.$route.params.id;
                    const response = await fetch(
                        `http://localhost:8081/api/works?acting=false&order=e.released%20desc&person_id=${id}`
                    );
                    this.other = await response.json();
                } catch (e) {
                    console.error(e)
                }
            },
            async updateKnownFor(option) {
                try {
                    this.person.known_for = option.id;
                    await fetch(`http://localhost:8081/api/people/${this.person.id}`, {
                        method: 'PUT',
                        body: JSON.stringify(this.person),
                        headers: {'Content-Type': 'application/json; charset=UTF-8'},
                    });
                    this.person = this.getPerson();
                } catch (e) {
                    console.error(e)
                }
            },
            formatDate(x) {
                x = new Date(x);
                x.setHours(x.getHours() + 3);
                return `${x.getDate()}.${x.getMonth() + 1}.${x.getFullYear()}`;
            },
        },
    }
</script>

<style scoped>

</style>